"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/visualBuilder/generators/generateThread.tsx
var generateThread_exports = {};
__export(generateThread_exports, {
  HighlightThread: () => HighlightThread,
  calculatePopupPosition: () => calculatePopupPosition,
  clearAllThreadStatus: () => clearAllThreadStatus,
  clearThreadStatus: () => clearThreadStatus,
  filterUnrenderedThreads: () => filterUnrenderedThreads,
  generateThread: () => generateThread,
  handleEmptyThreads: () => handleEmptyThreads,
  handleMissingThreads: () => handleMissingThreads,
  hideAllCollabIcons: () => hideAllCollabIcons,
  isCollabThread: () => isCollabThread,
  processThreadsBatch: () => processThreadsBatch,
  removeAllCollabIcons: () => removeAllCollabIcons,
  removeCollabIcon: () => removeCollabIcon,
  showAllCollabIcons: () => showAllCollabIcons,
  threadRenderStatus: () => threadRenderStatus,
  toggleCollabPopup: () => toggleCollabPopup,
  updateCollabIconPosition: () => updateCollabIconPosition,
  updatePopupPositions: () => updatePopupPositions
});
module.exports = __toCommonJS(generateThread_exports);
var import_preact = require("preact");
var import_goober = require("goober");
var import_CollabIndicator = __toESM(require("../components/Collab/CollabIndicator.cjs"), 1);
var import_configManager = __toESM(require("../../configManager/configManager.cjs"), 1);
var import_visualBuilderPostMessage = __toESM(require("../utils/visualBuilderPostMessage.cjs"), 1);
var import_postMessage = require("../utils/types/postMessage.types.cjs");
var import_jsx_runtime = require("preact/jsx-runtime");
var popupTopOffset = 43;
var popupLeftOffset = 9;
var hiddenClass = import_goober.css`
    display: none;
`;
function createPopupContainer(resolvedXPath, relativeX, relativeY, top, left, updateConfig, payload) {
  const popupContainer = document.createElement("div");
  popupContainer.setAttribute("field-path", resolvedXPath);
  popupContainer.setAttribute("relative", `x: ${relativeX}, y: ${relativeY}`);
  popupContainer.style.position = "absolute";
  popupContainer.style.top = `${top - popupTopOffset}px`;
  popupContainer.style.left = `${left - popupLeftOffset}px`;
  popupContainer.style.zIndex = updateConfig ? "1000" : "999";
  popupContainer.style.cursor = "pointer";
  popupContainer.className = "collab-thread";
  if (payload?._id) popupContainer.setAttribute("threaduid", payload._id);
  return popupContainer;
}
function appendPopupContainer(popupContainer) {
  const visualBuilderContainer = document.querySelector(
    ".visual-builder__container"
  );
  if (visualBuilderContainer) {
    let highlightCommentWrapper = visualBuilderContainer.querySelector(
      ".visual-builder__collab-wrapper"
    );
    if (!highlightCommentWrapper) {
      highlightCommentWrapper = document.createElement("div");
      highlightCommentWrapper.className = "visual-builder__collab-wrapper";
      visualBuilderContainer.appendChild(highlightCommentWrapper);
    }
    highlightCommentWrapper.appendChild(popupContainer);
  } else {
    document.body.appendChild(popupContainer);
  }
}
function generateThread(payload, options = {}) {
  const { isNewThread = false, updateConfig = false } = options;
  const config = import_configManager.default.get?.();
  let relativeX, relativeY, resolvedXPath;
  if (isNewThread) {
    ({ relativeX, relativeY, xpath: resolvedXPath } = payload);
  } else {
    const { position, elementXPath } = payload;
    ({ x: relativeX, y: relativeY } = position);
    resolvedXPath = elementXPath;
  }
  const element = getElementByXpath(resolvedXPath);
  if (!element) {
    return payload._id;
  }
  const rect = element.getBoundingClientRect();
  const top = rect.top + window.scrollY + relativeY * rect.height;
  const left = rect.left + window.scrollX + relativeX * rect.width;
  const popupContainer = createPopupContainer(
    resolvedXPath,
    relativeX,
    relativeY,
    top,
    left,
    updateConfig,
    payload
  );
  if (updateConfig && config?.collab.enable) {
    if (config?.collab.isFeedbackMode) {
      import_configManager.default.set("collab.isFeedbackMode", false);
    }
  }
  (0, import_preact.render)(
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
      import_CollabIndicator.default,
      {
        activeThread: !isNewThread ? payload : void 0,
        newThread: isNewThread
      }
    ),
    popupContainer
  );
  appendPopupContainer(popupContainer);
  return void 0;
}
function updateCollabIconPosition() {
  const icons = document.querySelectorAll(
    ".visual-builder__collab-wrapper .collab-thread"
  );
  const config = import_configManager.default.get?.();
  if (config?.collab?.pauseFeedback) return;
  icons.forEach((icon) => {
    if (!(icon instanceof HTMLElement)) return;
    const path = icon.getAttribute("field-path");
    const relative = icon.getAttribute("relative");
    if (!path || !relative) {
      console.error("Missing field-path or relative attribute.");
      return;
    }
    const match = relative.match(/x: ([\d.]+), y: ([\d.]+)/);
    if (!match) {
      console.error("Invalid relative attribute format.");
      return;
    }
    const relativeX = parseFloat(match[1]);
    const relativeY = parseFloat(match[2]);
    const targetElement = getElementByXpath(path);
    if (!targetElement) {
      icon.classList.add(hiddenClass);
      return;
    }
    const rect = targetElement.getBoundingClientRect();
    const x = rect.left + rect.width * relativeX + window.scrollX;
    const y = rect.top + rect.height * relativeY + window.scrollY;
    icon.style.top = `${y - popupTopOffset}px`;
    icon.style.left = `${x - popupLeftOffset}px`;
    icon.classList.remove(hiddenClass);
  });
}
function updatePopupPositions() {
  const popups = document.querySelectorAll(
    ".visual-builder__collab-wrapper .collab-thread .collab-popup"
  );
  const config = import_configManager.default.get?.();
  if (config?.collab?.pauseFeedback) return;
  popups.forEach((popup) => {
    if (popup && popup instanceof HTMLElement) {
      const parent = popup.closest(
        ".visual-builder__collab-wrapper .collab-thread"
      );
      if (!parent) {
        console.error(
          "Parent element with class 'collab-thread' not found."
        );
        return;
      }
      const button = parent.querySelector(
        ".visual-builder__collab-wrapper .collab-thread .collab-indicator"
      );
      if (!button || !(button instanceof HTMLElement)) {
        console.error(
          "Button with class 'collab-indicator' not found."
        );
        return;
      }
      calculatePopupPosition(button, popup);
    }
  });
}
function calculatePopupPosition(button, popup) {
  const buttonRect = button.getBoundingClientRect();
  const viewportHeight = window.innerHeight;
  const viewportWidth = window.innerWidth;
  let popupHeight = popup.offsetHeight || 198;
  let popupWidth = popup.offsetWidth || 334;
  const spaceAbove = buttonRect.top;
  const spaceBelow = viewportHeight - buttonRect.bottom;
  let top, left;
  if (spaceAbove >= popupHeight) {
    top = buttonRect.top - popupHeight - 8;
  } else if (spaceBelow >= popupHeight) {
    top = buttonRect.bottom + 8;
  } else {
    top = spaceBelow > spaceAbove ? buttonRect.bottom + 8 : Math.max(buttonRect.top - popupHeight - 8, 0);
  }
  left = buttonRect.left + buttonRect.width / 2 - popupWidth / 2;
  top = Math.max(top, 0);
  left = Math.max(left, 0);
  left = Math.min(left, viewportWidth - popupWidth);
  popup.style.top = `${top}px`;
  popup.style.left = `${left}px`;
  requestAnimationFrame(() => {
    const newPopupHeight = popup.offsetHeight;
    if (newPopupHeight !== popupHeight) {
      calculatePopupPosition(button, popup);
    }
  });
}
function removeAllCollabIcons() {
  const icons = document.querySelectorAll(
    ".visual-builder__collab-wrapper .collab-thread"
  );
  icons?.forEach((icon) => icon?.remove());
}
function hideAllCollabIcons() {
  const icons = document.querySelectorAll(
    ".visual-builder__collab-wrapper .collab-thread"
  );
  icons?.forEach((icon) => icon?.classList.add(hiddenClass));
}
function showAllCollabIcons() {
  const icons = document.querySelectorAll(
    ".visual-builder__collab-wrapper .collab-thread"
  );
  icons?.forEach((icon) => icon?.classList.remove(hiddenClass));
}
function removeCollabIcon(threadUid) {
  const thread = document.querySelector(`div[threaduid='${threadUid}']`);
  thread?.remove();
}
function toggleCollabPopup({
  threadUid = "",
  action
}) {
  document.dispatchEvent(
    new CustomEvent("toggleCollabPopup", {
      detail: { threadUid, action }
    })
  );
}
function HighlightThread(threadUid) {
  const config = import_configManager.default.get?.();
  if (config?.collab?.pauseFeedback) return;
  toggleCollabPopup({ threadUid, action: "open" });
}
function isCollabThread(target) {
  return Array.from(target.classList).some(
    (className) => className.startsWith("collab")
  );
}
function handleMissingThreads(payload) {
  import_visualBuilderPostMessage.default?.send(
    import_postMessage.VisualBuilderPostMessageEvents.COLLAB_MISSING_THREADS,
    { payload }
  );
}
function handleEmptyThreads() {
  const icons = document.querySelectorAll(
    ".visual-builder__collab-wrapper .collab-thread"
  );
  icons?.forEach((icon) => {
    if (!icon.hasAttribute("threaduid")) {
      icon.remove();
    }
  });
}
var retryConfig = {
  maxRetries: 3,
  retryDelay: 1e3
};
var isProcessingThreads = false;
var threadRenderStatus = /* @__PURE__ */ new Map();
function delay(ms) {
  return new Promise((resolve) => setTimeout(resolve, ms));
}
function getRenderStatus(threadId) {
  if (!threadRenderStatus.has(threadId)) {
    threadRenderStatus.set(threadId, {
      threadId,
      attempts: 0,
      isRendered: false
    });
  }
  return threadRenderStatus.get(threadId);
}
function updateRenderStatus(threadId, isRendered) {
  const status = getRenderStatus(threadId);
  status.isRendered = isRendered;
  threadRenderStatus.set(threadId, status);
}
function clearThreadStatus(threadId) {
  threadRenderStatus.delete(threadId);
}
function clearAllThreadStatus() {
  threadRenderStatus.clear();
  isProcessingThreads = false;
}
async function processThread(thread) {
  let status = getRenderStatus(thread._id);
  while (status.attempts < retryConfig.maxRetries) {
    try {
      const result = generateThread(thread, { isNewThread: false });
      if (result === void 0) {
        updateRenderStatus(thread._id, true);
        return void 0;
      }
      status.attempts++;
      updateRenderStatus(thread._id, false);
      if (status.attempts < retryConfig.maxRetries) {
        await delay(retryConfig.retryDelay);
      }
    } catch (error) {
      console.error(`Error rendering thread ${thread._id}:`, error);
      status.attempts++;
      if (status.attempts >= retryConfig.maxRetries) {
        break;
      }
      await delay(retryConfig.retryDelay);
    }
  }
  return thread._id;
}
async function processThreadsBatch(threads) {
  if (isProcessingThreads) return [];
  try {
    isProcessingThreads = true;
    const unrenderedThreads = filterUnrenderedThreads(threads);
    if (unrenderedThreads.length === 0) return [];
    const missingThreadIds = (await Promise.all(
      unrenderedThreads.map((thread) => processThread(thread))
    )).filter(Boolean);
    missingThreadIds.forEach(clearThreadStatus);
    return missingThreadIds;
  } finally {
    isProcessingThreads = false;
  }
}
function filterUnrenderedThreads(threads) {
  return threads.filter((thread) => {
    const existingThread = document.querySelector(
      `[threaduid="${thread._id}"]`
    );
    if (existingThread) {
      updateRenderStatus(thread._id, true);
      return false;
    }
    return true;
  });
}
function getElementByXpath(xpath) {
  const result = document.evaluate(
    xpath,
    document,
    null,
    XPathResult.FIRST_ORDERED_NODE_TYPE,
    null
  );
  return result.singleNodeValue;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  HighlightThread,
  calculatePopupPosition,
  clearAllThreadStatus,
  clearThreadStatus,
  filterUnrenderedThreads,
  generateThread,
  handleEmptyThreads,
  handleMissingThreads,
  hideAllCollabIcons,
  isCollabThread,
  processThreadsBatch,
  removeAllCollabIcons,
  removeCollabIcon,
  showAllCollabIcons,
  threadRenderStatus,
  toggleCollabPopup,
  updateCollabIconPosition,
  updatePopupPositions
});
//# sourceMappingURL=generateThread.cjs.map